// 256Color.DLL  -- Steven Lawrance (1994)  -- Aries Software --
// Freeware 256 Color Graphics Header Routine

#include <windowsx.h>
#include "\tcwin\examples\win31\steven\256dll.h"

#define _EXPORT huge
BOOL FAR PASCAL _export DlgProc(HWND hDlg, UINT message,
					WPARAM wParam, LPARAM lParam);
void WMDlgCommand_Handler(HWND hDlg, int id,
                          HWND hwndCtl, UINT codeNotify);
int FAR PASCAL _export WEP(int nShutDownFlag);

void FAR PASCAL _export RefreshPicPal(HWND hWnd, HPALETTE hNewPalette);
void FAR PASCAL _export StretchPicture(HWND hWnd, char PicName[20], HBITMAP BitmapHandle, HPALETTE hNewPalette, int wx, int wy, int ww, int wh, int bx, int by, int bw, int bh);
void FAR PASCAL _export RefreshPicture(HWND hWnd, HBITMAP BitmapHandle, HPALETTE hNewPalette, int wx, int wy, int bx, int by, int bw, int bh);
void FAR PASCAL _export InitInstance(HINSTANCE hInstance, int inst);
void FAR PASCAL _export AboutB256DLL(HWND hWnd);
BOOL FAR PASCAL _export DeletePic(HBITMAP BitmapHandle);
BOOL FAR PASCAL _export DeletePal(HPALETTE hNewPalette);
LPSTR FAR PASCAL _export B256DLL(HWND hWnd, LPCSTR lpszTitle);
HBITMAP FAR PASCAL _export GetPicFast(HWND hWnd, char PicName[20]);
HBITMAP FAR PASCAL _export GetPic256(HWND hWnd, char PicName[20]);
HPALETTE FAR PASCAL _export GetPicPal(void);
HINSTANCE FAR PASCAL _export GetDLLInstance(void);

short nColors, Count;
HPALETTE hNewPalette;
LPBITMAPINFO pBits;
HINSTANCE ghInstance;
HINSTANCE dllInstance;

#pragma argsused
int FAR PASCAL LibMain (HINSTANCE hInstance, WORD wDataSeg, WORD wHeapSize, LPSTR lpszCmdLine)
{
  if (wHeapSize > 0)
    UnlockData(0);
  pBits = NULL;
  hNewPalette = NULL;
  dllInstance = hInstance;
  return 1;
}

#pragma argsused
int FAR PASCAL _export WEP(int nShutDownFlag)
{
  DeletePal(hNewPalette);
  DeleteObject(hNewPalette);
  return 1;
}

void FAR PASCAL _export InitInstance(HINSTANCE hInstance, int inst)
{
  if (inst != 0)
  {
    ghInstance = dllInstance;
  }
  if (inst == 0)
  {
    ghInstance = hInstance;
  }
}

#pragma argsused
void FAR PASCAL _export RefreshPicPal(HWND hWnd, HPALETTE hNewPalette)
{
	if (hNewPalette)
	{
          HPALETTE hOldPalette;
	  HDC hDC = GetDC(hWnd);
	  hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
	  RealizePalette(hDC);
	  SelectPalette(hDC,hOldPalette,FALSE);
	  ReleaseDC(hWnd,hDC);
          DeleteObject(hOldPalette);
	};
}

#pragma argsused
void FAR PASCAL _export StretchPicture(HWND hWnd, char PicName[20], HBITMAP BitmapHandle, HPALETTE hNewPalette, int wx, int wy, int ww, int wh, int bx, int by, int bw, int bh)
{
      HPALETTE hOldPalette;
      HDC hDC = GetDC(hWnd);
      BITMAP BM;
      HGLOBAL hBitmap = NULL;
      RECT rect;

      hBitmap  = LoadResource(ghInstance, FindResource(ghInstance, (LPSTR)PicName, RT_BITMAP));
      GetClientRect(hWnd, &rect);
      GetObject(BitmapHandle, sizeof(BITMAP), &BM);
	 if (wx == 0)
	   {
	   wx = rect.left;
	   };
	 if (wy == 0)
	   {
	   wy = rect.top;
	   };
	 if (ww == 0)
	   {
	   ww = rect.right;
	   };
	 if (wh == 0)
	   {
	   wh = rect.bottom;
	   };
	 if (bw == 0)
	   {
	   bw = BM.bmWidth;
	   };
	 if (bh == 0)
	   {
	   bh = BM.bmHeight;
	   };
      pBits = (LPBITMAPINFO)GlobalLock(hBitmap);
      hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
      RealizePalette(hDC);
      StretchDIBits(hDC, wx, wy, ww, wh, bx, by, bw, bh, ((LPSTR) pBits + 40) + (nColors * sizeof(RGBQUAD)), pBits, DIB_RGB_COLORS, SRCCOPY);
      SelectPalette(hDC,hOldPalette,FALSE);
      FreeResource(hBitmap);
      ReleaseDC(hWnd,hDC);
      DeleteObject(hBitmap);
      DeleteObject(hOldPalette);
      ValidateRect(hWnd,NULL);
}

#pragma argsused
void FAR PASCAL _export RefreshPicture(HWND hWnd, HBITMAP BitmapHandle, HPALETTE hNewPalette, int wx, int wy, int bx, int by, int bw, int bh)
{
	 RECT rect;
	 HBITMAP OldBitmapHandle;
	 BITMAP BM;
	 HDC hDC = GetDC(hWnd);
         HDC MemoryDC;
	 HPALETTE hOldPal;
	 GetClientRect(hWnd, &rect);
         GetObject(BitmapHandle, sizeof(BITMAP), &BM);
     	 if (wx == 0)
	   {
	   wx = rect.left;
	   };
	 if (wy == 0)
	   {
	   wy = rect.top;
	   };
	 if (bw == 0)
	   {
	   bw = BM.bmWidth;
	   };
	 if (bh == 0)
	   {
	   bh = BM.bmHeight;
	   };
	 if ( BitmapHandle )
           {
           MemoryDC = CreateCompatibleDC(hDC);
           OldBitmapHandle = (HBITMAP)SelectObject(MemoryDC, BitmapHandle);
	   hOldPal = SelectPalette( hDC, hNewPalette, FALSE);
//           SetBkColor(hDC, 0L);
//           SetTextColor(hDC, 0xFFFFFFL);
	   BitBlt(hDC, wx, wy, bw, bh, MemoryDC, bx, by, SRCCOPY);
	   SelectPalette( hDC, hOldPal, FALSE);
	   SelectObject(MemoryDC, OldBitmapHandle);
	   DeleteDC(MemoryDC);
	   ValidateRect(hWnd,NULL);
	   };
         ReleaseDC(hWnd, hDC);
         ReleaseDC(hWnd, MemoryDC);
	 DeleteObject(OldBitmapHandle);
	 DeleteObject(hOldPal);
}

HINSTANCE FAR PASCAL _export GetDLLInstance(void)
{
  return dllInstance;
}

void FAR PASCAL _export AboutB256DLL(HWND hWnd)
{
  MessageBeep(MB_ICONASTERISK);
  MessageBox(hWnd, "This DLL file was made by Aries Software in 1994 by Steven Lawrance.  You may distribute this file if you wish to do so.", "B256DLL for Windows", MB_OK | MB_ICONASTERISK);
}

#pragma argsused
HBITMAP FAR PASCAL _export GetPicFast(HWND hWnd, char PicName[20])
{
      HPALETTE hOldPalette;
      HGLOBAL hBitmap = NULL;
      HBITMAP BitmapHandle;
      HDC hDC = GetDC(hWnd);
      hBitmap = LoadResource(ghInstance, FindResource(ghInstance, (LPSTR)PicName, RT_BITMAP));
      pBits = (LPBITMAPINFO)GlobalLock(hBitmap);
      hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
      RealizePalette(hDC);
      BitmapHandle = CreateDIBitmap(hDC, (LPBITMAPINFOHEADER)pBits, CBM_INIT, ((LPSTR) pBits + 40) + (nColors * sizeof(RGBQUAD)), pBits, DIB_RGB_COLORS);
      SelectPalette(hDC,hOldPalette,FALSE);
      FreeResource(hBitmap);
      ReleaseDC(hWnd,hDC);
      DeleteObject(hOldPalette);
      return BitmapHandle;
}

#pragma argsused
HBITMAP FAR PASCAL _export GetPic256(HWND hWnd, char PicName[20])
{
      HPALETTE hOldPalette;
      RGBQUAD FAR  *pRgb;
      LPLOGPALETTE lpDstPal;
      HBITMAP BitmapHandle;

      HGLOBAL hBitmap = NULL;
      hNewPalette     = NULL;
      hBitmap  = LoadResource(ghInstance,
			    FindResource(ghInstance,
					(LPSTR)PicName, RT_BITMAP));
      if (!hBitmap)
      {
	MessageBeep(MB_ICONSTOP);
      }
      if ( hBitmap )
	{
	HDC hDC = GetDC(hWnd);
	pBits = (LPBITMAPINFO)GlobalLock(hBitmap);
	nColors = 1<<(pBits->bmiHeader.biBitCount);
	if ( nColors)
	  {
	  lpDstPal = (LPLOGPALETTE) GlobalLock( GlobalAlloc(
	  GHND, sizeof(LOGPALETTE) + ( (nColors - 1) * sizeof(PALETTEENTRY) )));
	  lpDstPal->palNumEntries = nColors;
	  lpDstPal->palVersion    = 0x300;
	  pRgb = pBits->bmiColors;
	  for (Count = 0; Count <= nColors; Count++)
	    {
	    lpDstPal->palPalEntry[Count].peRed   = pRgb[Count].rgbRed;
	    lpDstPal->palPalEntry[Count].peGreen = pRgb[Count].rgbGreen;
	    lpDstPal->palPalEntry[Count].peBlue  = pRgb[Count].rgbBlue;
	    lpDstPal->palPalEntry[Count].peFlags = 0;
	    }
	  }
	hNewPalette = CreatePalette(lpDstPal);
	GlobalFree( (HANDLE) GlobalHandle( HIWORD( lpDstPal) ) );
	hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
	RealizePalette(hDC);
	BitmapHandle = CreateDIBitmap(hDC, (LPBITMAPINFOHEADER)pBits, CBM_INIT, ((LPSTR) pBits + 40) + (nColors * sizeof(RGBQUAD)), pBits, DIB_RGB_COLORS);
	SelectPalette(hDC,hOldPalette,FALSE);
	FreeResource(hBitmap);
	ReleaseDC(hWnd,hDC);
	DeleteObject(hOldPalette);
	}

      return BitmapHandle;
}

#pragma argsused
HPALETTE FAR PASCAL _export GetPicPal(void)
{
      return hNewPalette;
}

#pragma argsused
BOOL FAR PASCAL _export DeletePic(HBITMAP BitmapHandle)
{
      return DeleteObject(BitmapHandle);
}

#pragma argsused
BOOL FAR PASCAL _export DeletePal(HPALETTE hNewPalette)
{
      return DeleteObject(hNewPalette);
}

#pragma argsused
LPSTR FAR PASCAL _export B256DLL(HWND hWnd, LPCSTR lpszTitle)
{
  DLGPROC AbtDlgProc;
  char szBuf[20];

  LoadString(ghInstance, 0, szBuf, 20);
  AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, dllInstance);
  DialogBoxParam(dllInstance, "B256DLL", hWnd, AbtDlgProc, (LPARAM) lpszTitle);
  FreeProcInstance((FARPROC)AbtDlgProc);
  InvalidateRect(hWnd, NULL, TRUE);
  return szBuf;
}

#pragma argsused
BOOL FAR PASCAL _export DlgProc(HWND hDlg, UINT message,
					WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      LPCSTR lpszTitle = ((LPSTR) lParam);
      char Text[20];
      int i;
      SetWindowText(hDlg, lpszTitle);

      for(i=1; i<=500; i++)
      {
	if (LoadString(ghInstance, i, Text, 20) == 0)
	  break;

	SendDlgItemMessage(hDlg, ID_LISTBOX, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) Text));
      }
      LoadString(ghInstance, 1, Text, 20);
      SendDlgItemMessage(hDlg, ID_LISTBOX, LB_SELECTSTRING, -1, (LPARAM) ((LPSTR) Text));
      return TRUE;
    }
    case WM_COMMAND :
    {
      return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam,
                                    WMDlgCommand_Handler);
    }
  }
  return FALSE;
}

#pragma argsused
void WMDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case ID_PICOPEN :
    {
      codeNotify = LBN_DBLCLK;
    }
    case ID_LISTBOX :
    {
      char szBuf[20];
      if (codeNotify == LBN_DBLCLK)
      {
	DWORD dwIndex;

	dwIndex = SendDlgItemMessage(hDlg, ID_LISTBOX, LB_GETCURSEL, 0, 0);
        if (dwIndex != LB_ERR)
	{
	  SendDlgItemMessage(hDlg, ID_LISTBOX, LB_GETTEXT, (WPARAM) dwIndex, (LPARAM) ((LPSTR) szBuf));
	  EndDialog(hDlg, 0);
	}
	if (dwIndex == LB_ERR)
	{
          char Text[20];
          LoadString(ghInstance, 1, Text, 20);
	  SendDlgItemMessage(hDlg, ID_LISTBOX, LB_SELECTSTRING, -1, (LPARAM) ((LPSTR) Text));
	}
      }
      break;
    }
    case ID_PICCANCEL :
    {
      EndDialog(hDlg, 0);
      break;
    }
  }
}