#include <windowsx.h>
#include <string.h>
#include <256color.h>
#include "test256.h"

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam);
BOOL CALLBACK _export DlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
void WMCommand_Handler(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
void WMDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);
HINSTANCE    ghInstance;
HMENU       hMenu;
HBITMAP hBitmap;
HPALETTE hPalette;
static char Buffer[9];
char Pint[] = "n";
char Pmod[] = "r";
char PicName[20] = "Default";
unsigned int twx = 0;
unsigned int twy = 0;
unsigned int tww = 0;
unsigned int twh = 0;
unsigned int tbx = 0;
unsigned int tby = 0;
unsigned int tbw = 0;
unsigned int tbh = 0;
unsigned int cg = 0;
unsigned int GetPic = 0;

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdParam, int nCmdShow)
{
   char        ProgName[] = "Test256 Header Tester";
   HWND        hWnd;
   MSG         msg;

   if (!hPrevInstance)
   {
      WNDCLASS    wndclass;

      wndclass.style         = CS_VREDRAW | CS_HREDRAW;
      wndclass.lpfnWndProc   = (WNDPROC) MainWndProc;
      wndclass.hInstance     = hInstance;
      wndclass.hIcon         = LoadIcon (wndclass.hInstance, "test256");
      wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wndclass.lpszMenuName  = "MAIN";
      wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
      wndclass.lpszMenuName  = NULL;
      wndclass.cbClsExtra    = 0;
      wndclass.cbWndExtra    = 0;
      wndclass.lpszClassName = ProgName;

      RegisterClass(&wndclass);
   }


   ghInstance = hInstance;

   hMenu = LoadMenu(ghInstance, "MAIN");
   SetMenu(hWnd, hMenu);
   hWnd = CreateWindow(ProgName,"Test256 Bitmap Routine",
		       WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_THICKFRAME | WS_MAXIMIZEBOX,
                       CW_USEDEFAULT, CW_USEDEFAULT,          
                       328, 246,          
                       NULL, hMenu, hInstance, NULL);

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   while (GetMessage(&msg, NULL, 0, 0))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
   return msg.wParam;
}

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam)
{
   switch (message)
   {
      case WM_SETFOCUS :
      {
	if (strcmp(Pint, "y") == 0)
	{
	  RefreshPicPal(hWnd, hPalette);
	  if (cg == 0)
	  {
            SendMessage(hWnd, WM_PAINT, 0, 0L);
	  };
	  if (cg == 1)
	  {
	    cg = 0;
          };
	};
        return 0;
      }
      case WM_PAINT :
      {
      HDC         PaintDC;
      RECT        rect;
      PAINTSTRUCT ps;
       if (strcmp(PicName, "clearbitmap") == 0)
	{
	 PaintDC = BeginPaint(hWnd, &ps);
         GetClientRect(hWnd, &rect);
	 DrawText(PaintDC, (LPCSTR)"Screen Cleared",
                  -1, &rect, DT_SINGLELINE | DT_CENTER | DT_VCENTER);
         EndPaint(hWnd, &ps);
	};
       if (strcmp(PicName, "clearbitmap") != 0)
       {
	if (strcmp(Pint, "n") == 0)
	{
	  hBitmap = GetPic256(hWnd, "Default");
          hPalette = GetPicPal();
	  strcpy(Pint, "y");
	};
        if (strcmp(Pmod, "r") == 0)
	{
	  RefreshPicture(hWnd, hBitmap, hPalette, twx, twy, tbx, tby, tbw, tbh);
	};
	if (strcmp(Pmod, "s") == 0)
	{
	  StretchPicture(hWnd, PicName, hBitmap, hPalette, twx, twy, tww, twh, tbx, tby, tbw, tbh);
	};
       }
       return 0;
      }
      case WM_DESTROY :
      {
	DeletePic(hBitmap);
	DeletePal(hPalette);
        DeleteObject(hBitmap);
        DeleteObject(hPalette);
	DeleteObject(hMenu);
	PostQuitMessage(0);
        return 0;
      }
      case WM_COMMAND :
      {
	 return HANDLE_WM_COMMAND(hWnd, wParam, lParam, WMCommand_Handler);
      }
   }
   return DefWindowProc (hWnd, message, wParam, lParam);
}

#pragma argused
BOOL CALLBACK _export DlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
	SendDlgItemMessage(hDlg, ID_LISTBOX, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) "*Clear*"));
	SendDlgItemMessage(hDlg, ID_LISTBOX, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) "Default"));
	SendDlgItemMessage(hDlg, ID_LISTBOX, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) "Picture 1"));
	SendDlgItemMessage(hDlg, ID_LISTBOX, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) "Picture 2"));
	SendDlgItemMessage(hDlg, ID_LISTBOX, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) "Picture 3"));
	SendDlgItemMessage(hDlg, ID_LISTBOX, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) "Picture 4"));
	if (strcmp(PicName, "clearbitmap") == 0)
	  strcpy(PicName, "*Clear*");
	if (strcmp(PicName, "Pic1") == 0)
	  strcpy(PicName, "Picture 1");
	if (strcmp(PicName, "Pic2") == 0)
	  strcpy(PicName, "Picture 2");
	if (strcmp(PicName, "Pic3") == 0)
	  strcpy(PicName, "Picture 3");
	if (strcmp(PicName, "Pic4") == 0)
	  strcpy(PicName, "Picture 4");
	SendDlgItemMessage(hDlg, ID_LISTBOX, LB_SELECTSTRING, 0, (LPARAM) ((LPSTR) PicName));
	SetDlgItemInt(hDlg, RWX, twx, FALSE);
	SetDlgItemInt(hDlg, RWY, twy, FALSE);
	SetDlgItemInt(hDlg, RWW, tww, FALSE);
	SetDlgItemInt(hDlg, RWH, twh, FALSE);
	SetDlgItemInt(hDlg, RBX, tbx, FALSE);
	SetDlgItemInt(hDlg, RBY, tby, FALSE);
	SetDlgItemInt(hDlg, RBW, tbw, FALSE);
	SetDlgItemInt(hDlg, RBH, tbh, FALSE);
	if (strcmp(Pmod, "r") == 0)
	  SendDlgItemMessage(hDlg, ID_RPIC, BM_SETCHECK, 1, 0);

	if (strcmp(Pmod, "s") == 0)
	  SendDlgItemMessage(hDlg, ID_SPIC, BM_SETCHECK, 1, 0);

	if (GetPic == 0)
	  SendDlgItemMessage(hDlg, ID_GETPICPAL, BM_SETCHECK, 1, 0);

	if (GetPic == 1)
	  SendDlgItemMessage(hDlg, ID_GETPICFAST, BM_SETCHECK, 1, 0);

	return TRUE;
      }

      case WM_COMMAND :
      {
	 return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam,
	                                WMDlgCommand_Handler);
      }
   }

   return FALSE;
}

#pragma argsused
void WMCommand_Handler(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify)
{
   switch (id)
   {
      case CM_TEST :
      {
      DLGPROC AbtDlgProc;
      cg = 1;
      AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, ghInstance);
      DialogBox(ghInstance, "TESTBITMAP", hWnd, AbtDlgProc);
      FreeProcInstance((FARPROC)AbtDlgProc);
      InvalidateRect(hWnd, NULL, TRUE);
      if (cg == 2)
      {
	  if (GetPic == 0)
	  {
	    DeletePic(hBitmap);
	    DeletePal(hPalette);
	    hBitmap = GetPic256(hWnd, PicName);
	    hPalette = GetPicPal();
	  };
          if (GetPic == 1)
          {
            DeletePic(hBitmap);
	    hBitmap = GetPicFast(hWnd, PicName);
	  };
	cg = 0;
      };
      break;
      }
      case CM_EXITPRG :
      {
        DestroyWindow(hWnd);
	break;
      }
    }
}

#pragma argsused
void WMDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
      case ID_RPIC :
      {
	SendDlgItemMessage(hDlg, ID_RPIC, BM_SETCHECK, 1, 0);
	SendDlgItemMessage(hDlg, ID_SPIC, BM_SETCHECK, 0, 0);
	break;
      }
      case ID_SPIC :
      {
	SendDlgItemMessage(hDlg, ID_RPIC, BM_SETCHECK, 0, 0);
	SendDlgItemMessage(hDlg, ID_SPIC, BM_SETCHECK, 1, 0);
	break;
      }
      case ID_GETPICPAL :
      {
	SendDlgItemMessage(hDlg, ID_GETPICPAL, BM_SETCHECK, 1, 0);
	SendDlgItemMessage(hDlg, ID_GETPICFAST, BM_SETCHECK, 0, 0);
	break;
      }
      case ID_GETPICFAST :
      {
	SendDlgItemMessage(hDlg, ID_GETPICPAL, BM_SETCHECK, 0, 0);
	SendDlgItemMessage(hDlg, ID_GETPICFAST, BM_SETCHECK, 1, 0);
	break;
      }
      case ID_OK :
      {
	 HWND  hCtrl;
         DWORD result;
	 char szBuf[20];
	 DWORD dwIndex;
	 dwIndex = SendDlgItemMessage(hDlg, ID_LISTBOX, LB_GETCURSEL, 0, 0);
	 hCtrl = GetDlgItem(hDlg, ID_GETPICPAL);
	 result = SendMessage(hCtrl, BM_GETCHECK, 0, 0L);
	 if (result)
           GetPic = 0; 

	 hCtrl = GetDlgItem(hDlg, ID_GETPICFAST);
	 result = SendMessage(hCtrl, BM_GETCHECK, 0, 0L);
	 if (result)
	   GetPic = 1;

	 hCtrl = GetDlgItem(hDlg, ID_RPIC);
	 result = SendMessage(hCtrl, BM_GETCHECK, 0, 0L);
	 if (result)
           strcpy(Pmod, "r"); 

	 hCtrl = GetDlgItem(hDlg, ID_SPIC);
	 result = SendMessage(hCtrl, BM_GETCHECK, 0, 0L);
	 if (result)
           strcpy(Pmod, "s"); 

	 twx = GetDlgItemInt(hDlg, RWX, NULL, FALSE);
	 twy = GetDlgItemInt(hDlg, RWY, NULL, FALSE);
	 if (strcmp(Pmod, "s") == 0)
         {
	   tww = GetDlgItemInt(hDlg, RWW, NULL, FALSE);
	   twh = GetDlgItemInt(hDlg, RWH, NULL, FALSE);
         };
	 tbx = GetDlgItemInt(hDlg, RBX, NULL, FALSE);
	 tby = GetDlgItemInt(hDlg, RBY, NULL, FALSE);
	 tbw = GetDlgItemInt(hDlg, RBW, NULL, FALSE);
	 tbh = GetDlgItemInt(hDlg, RBH, NULL, FALSE);
	 EndDialog(hDlg, 0);
	 if (dwIndex != LB_ERR)
	 {
	   SendDlgItemMessage(hDlg, ID_LISTBOX, LB_GETTEXT, (WPARAM) dwIndex, (LPARAM) ((LPSTR) szBuf));
	   if ( strcmp(szBuf, "*Clear*") == 0 )
           {
             strcpy(PicName, "clearbitmap");
	   };
	   if ( strcmp(szBuf, "Default") == 0 )
	   {
	     strcpy(PicName, "Default");
	   };
	   if ( strcmp(szBuf, "Picture 1") == 0 )
           {
             strcpy(PicName, "Pic1");
	   };
	   if ( strcmp(szBuf, "Picture 2") == 0 )
           {
             strcpy(PicName, "Pic2");
	   };
	   if ( strcmp(szBuf, "Picture 3") == 0 )
           {
             strcpy(PicName, "Pic3");
	   };
	   if ( strcmp(szBuf, "Picture 4") == 0 )
           {
             strcpy(PicName, "Pic4");
	   };
	 };
	 cg = 2;
	 EndDialog(hDlg, 0);
	 break;
      }
      case ID_CANCEL :
      {
	cg = 0;
	if (strcmp(PicName, "*Clear*") == 0)
	  strcpy(PicName, "clearbitmap");
	if (strcmp(PicName, "Picture 1") == 0)
	  strcpy(PicName, "Pic1");
	if (strcmp(PicName, "Picture 2") == 0)
	  strcpy(PicName, "Pic2");
	if (strcmp(PicName, "Picture 3") == 0)
	  strcpy(PicName, "Pic3");
	if (strcmp(PicName, "Picture 4") == 0)
	  strcpy(PicName, "Pic4");
	EndDialog(hDlg, 0);
	break;
      }
   }
}
